#include "stdio.h"

#include "znfat/znFAT.h"
#include "sdx.h"
#include "uart.h"
#include "myfun.h"

#include "sensor.h"
#include "fifo.h"

//===========================================
// ˳OV7670+SDʵ
// ļϵͳ znFAT
//   QQ 987582714
//===========================================

sfr P1M0 = 0x92;
sfr P1M1 = 0x91;

struct znFAT_Init_Args idata Init_Args; //ʼ
struct FileInfo idata fileinfo; //ļϢ

struct DateTime dt; //ʱṹ

unsigned char cur_status=0;

unsigned char buf[192];

unsigned char code bmp_header[54]=
{
 0x42,0x4D,0x38,0x58,0x02,0x00,0x00,0x00,0x00,0x00,0x36,0x00,0x00,0x00,0x28,0x00,
 0x00,0x00,0x40,0x01,0x00,0x00,0xF0,0x00,0x00,0x00,0x01,0x00,0x10,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x12,0x0B,0x00,0x00,0x12,0x0B,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00
};

//==================================================================

void int0(void) interrupt 0
{
 EX0=0; //رж

 if(cur_status==0) //ʱ״̬Ϊ0˵һͼĿʼʼFIFO
 {
  FIFO_WEN=1;
  cur_status=1; //Ϊ1
        
  EX0=1;	//ж
 }
 else 
  if(cur_status==1)	//˵˴ΪͼĽ༴һͼĿʼ
  {
   FIFO_WEN=0;
   cur_status=2;
  }
}

int main()
{ 
 unsigned char idata  i=0;

 FIFO_OE=0;

 P1M1=0x40;	//P16
 P1M0=0xa8; //ʹ51ƬSDģ飬죬ǿIO

 UART_Init();
 UART_Send_Str("ڳʼ.");UART_Send_Enter(); 

 znFAT_Device_Init(); //洢豸ʼ
 UART_Send_Str("洢豸ʼ.");UART_Send_Enter(); 

 znFAT_Select_Device(0,&Init_Args); //ѡ豸

 znFAT_Init(); //ļϵͳʼ
 UART_Send_Str("ļϵͳʼ.");UART_Send_Enter(); 

 while(!Sensor_init());  

 UART_Send_Str("ͷоƬʼ.");UART_Send_Enter(); 

 //==============================================================================
   
 dt.date.year=2012; dt.date.month=12; dt.date.day=21;
 dt.time.hour=15; dt.time.min=14; dt.time.sec=35;
		  
 znFAT_Create_File(&fileinfo,"/znmcu6.bmp",&dt);

 UART_Send_Str("ͼļѴɹ.");UART_Send_Enter();

 znFAT_WriteData(&fileinfo,54,bmp_header);

 UART_Send_Str("ͼļͷд.");UART_Send_Enter();

 IT0=1; //½ش
 EX0=1;	//ⲿж0
 EA=1;	//ж

 UART_Send_Str("ⲿжѿȴͼ...");UART_Send_Enter();

 while(1)
 {
  if(cur_status==2) //ԽFIFOѾһͼ
  {
   cur_status=0;

   UART_Send_Str("ͼѻȡ.");UART_Send_Enter();

   FIFO_Reset_Read_Addr(); //FIFOĶָָ0ַ

   UART_Send_Str("ʼͼдļ.");UART_Send_Enter();

   for(i=0;i<200;i++)
   {
    FIFO_Read_Words(96,buf); //FIFOȡ
    znFAT_WriteData(&fileinfo,192,buf); //дļ
    FIFO_Read_Words(96,buf); //FIFOȡ
    znFAT_WriteData(&fileinfo,192,buf); //дļ
    FIFO_Read_Words(96,buf); //FIFOȡ
    znFAT_WriteData(&fileinfo,192,buf); //дļ
    FIFO_Read_Words(96,buf); //FIFOȡ
    znFAT_WriteData(&fileinfo,192,buf); //дļ
   }

   UART_Send_Str("ͼд.");UART_Send_Enter();

   znFAT_Close_File(&fileinfo);

   znFAT_Flush_FS();
  }
 }

 while(1);
 return 0;
}